SystemOrganization addCategory: #'Irka-Core'!
SystemOrganization addCategory: #'Irka-GUI'!
SystemOrganization addCategory: #'Irka-Test'!

StandardWindow subclass: #IrkaBrowser
	instanceVariableNames: 'servers chans users messagePanels messageContainer activeChannel typingBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaBrowser methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 19:23'!
createLeftRightPane
	^ PanelMorph new
		layoutPolicy: RowLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill;			
		cellInset: 1;
		layoutInset: 1;
		yourself! !

!IrkaBrowser methodsFor: 'private' stamp: 'AttilaMagyar 9/26/2012 20:46'!
createListBox: anIrkaListModel
	^ (PluggableListMorph 
				on: anIrkaListModel list: #list selected: #index changeSelected: #index: menu: #menu)
				hResizing: #spaceFill; 
				vResizing: #spaceFill;
				yourself! !

!IrkaBrowser methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 19:23'!
createMessageContainer
	^ PanelMorph new
		layoutPolicy: TableLayout new;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself! !

!IrkaBrowser methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 19:23'!
createTopBottomPane
	^ PanelMorph new
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		cellInset: 1;
		layoutInset: 1;		
		yourself.! !

!IrkaBrowser methodsFor: 'events' stamp: 'AttilaMagyar 10/28/2012 20:03'!
enteredText: aString
	| messagesMorph |
	activeChannel message: aString.
	
	messagesMorph := messagePanels at: activeChannel.
	messagesMorph addMessage: ('[yourself]>> ', aString).
! !

!IrkaBrowser methodsFor: 'events' stamp: 'AttilaMagyar 10/28/2012 19:06'!
iJoinedTo: anIrkaJoined
	self switchToChan: anIrkaJoined chan! !

!IrkaBrowser methodsFor: 'initialization' stamp: 'AttilaMagyar 10/28/2012 20:14'!
initWindow
	| contentPane browserPane controlPane serverList chanList userList |
	self title: 'Irka browser'.
	typingBox := IrkaTypingBox 
						on: self
						entered: #enteredText:.						

	messageContainer := self createMessageContainer.
	contentPane := self createTopBottomPane.
	browserPane := self createLeftRightPane.
	controlPane := self createLeftRightPane.
	servers := IrkaListModel new.
	servers add: 'irc.freenode.net'.	"TODO"
	chans := IrkaListModel new.
	users := IrkaListModel new.
	serverList := self createListBox: servers.
	chanList := self createListBox: chans.
	userList := self createListBox: users.
	browserPane
		addMorph: userList;
		addMorph: chanList;
		addMorph: serverList.
	contentPane 
		addMorph: typingBox;
		addMorph: messageContainer;
		addMorph: browserPane.
	self addMorph: contentPane frame: (0 @ 0 corner: 1 @ 1)! !

!IrkaBrowser methodsFor: 'initialization' stamp: 'AttilaMagyar 9/24/2012 22:55'!
initialize
	super initialize.
	self initWindow.
	messagePanels := Dictionary new.! !

!IrkaBrowser methodsFor: 'events' stamp: 'AttilaMagyar 10/27/2012 01:01'!
messageReceived: anIrkaMessage
	| messagesMorph |
	messagesMorph := messagePanels at: anIrkaMessage chan.
	messagesMorph addMessage: ('[', anIrkaMessage user nick ,']>> ', anIrkaMessage message).
	
	users clean. "TODO"
	anIrkaMessage chan nicks do: [:each | users add: each ].! !

!IrkaBrowser methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 19:35'!
switchToChan: anIrkaChannel
	| messagesMorph |	
	activeChannel := anIrkaChannel.
	messagesMorph := messagePanels
		at: anIrkaChannel 
		ifAbsentPut: 
			[ chans add: anIrkaChannel.
			IrkaMessagesMorph new ].
	
	WorldState addDeferredUIMessage: [ 
		messageContainer removeAllMorphs.
		messageContainer addMorph: messagesMorph ].
	
	anIrkaChannel announcer 
							on: IrkaChanMessage 
							send: #messageReceived: to: self.					! !

!IrkaBrowser methodsFor: 'events' stamp: 'AttilaMagyar 10/27/2012 00:20'!
userJoinedTo: anIrkaJoined
! !

PluggableTextMorph subclass: #IrkaTypingBox
	instanceVariableNames: 'text listener enterSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaTypingBox class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/28/2012 19:49'!
on: listener entered: selector
	^ self new
		setListener: listener
		selector: selector! !

!IrkaTypingBox methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/28/2012 19:46'!
initialize 
	super initialize.
	self on: self
		text: #typedMessage
		accept: #typedMessage:
		readSelection: nil
		menu: nil.										
	self
		vResizing: #rigid;
		hideVScrollBarIndefinitely: true;
		hResizing: #spaceFill;
		acceptOnCR: true.	! !

!IrkaTypingBox methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/28/2012 19:50'!
setListener: listenerObject selector: selectorSymbol
	listener := listenerObject.
	enterSelector := selectorSymbol.! !

!IrkaTypingBox methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 19:43'!
typedMessage
	^ text! !

!IrkaTypingBox methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 20:02'!
typedMessage: aString	
	text := aString.
	listener 
		perform: enterSelector 
		with: text.
	self setText: ''.! !

BabyMockTestCase subclass: #IrkaChannelTest
	instanceVariableNames: 'chan translator testUser listener chanName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaChannelTest methodsFor: 'running' stamp: 'AttilaMagyar 10/27/2012 22:33'!
setUp	
	chanName := '#mychan'.
	translator := context mock: 'translator'.
	chan := IrkaChannel 
					named: chanName 
					translator: translator.
	testUser := IrkaUser parse: 'nick!!ident@host'.
	listener := context mock: 'chan listener'.	
	context visualize: chan.! !

!IrkaChannelTest methodsFor: 'private' stamp: 'AttilaMagyar 10/27/2012 22:31'!
subscribeToChanMessage
	chan announcer 
			on: IrkaChanMessage 
			send: #chanMsg: 
			to: listener.							
! !

!IrkaChannelTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/27/2012 22:33'!
testThatItCanBeLeft
	translator should receive: #translateLeave:; with: chanName.
	chan leave.! !

!IrkaChannelTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/27/2012 22:33'!
testThatItCanSendMessagesToTheChan
	translator should receive: #translateMessage:to:; with: 'text' and: chanName.
	chan message: 'text'.! !

!IrkaChannelTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/27/2012 23:26'!
testThatItNotifiesAboutIncomingMessages
	self subscribeToChanMessage.
	listener should 
					receive: #chanMsg:; 
					with: (IrkaChanMessage 
								message: 'text' 
								on: chan 
								fromUser: testUser).	
	chan message: 'text' from: testUser.! !

BabyMockTestCase subclass: #IrkaSessionTest
	instanceVariableNames: 'session translator me listener meUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaSessionTest methodsFor: 'matchers' stamp: 'AttilaMagyar 10/26/2012 23:55'!
chan: anIrkaChannel hasNicks: anArray 
	^ anIrkaChannel nicks = (OrderedCollection newFrom: anArray).! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 18:15'!
joined: chanName
	| joinedChan |
	session announcer on: IrkaUserJoined do: [:act | joinedChan := act chan ].
	session translated: (IrkaTranslatedEvent joined: meUser to: chanName).
	^ joinedChan! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 10/27/2012 20:36'!
registerNick
	translator can receive: #translateRegisterUser:; with: me.
	session register: me.
! !

!IrkaSessionTest methodsFor: 'running' stamp: 'AttilaMagyar 10/28/2012 18:29'!
setUp
	me := 'mynick'.
	meUser := IrkaUser parse: (me, '!!ident@host.hu').
	session := IrkaSession new.
	translator := context mock: 'translator'.
	listener := context mock: 'listener'.
	session translator: translator.
	context visualize: session.! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 17:41'!
subscribeToSession: aAnnouncement
	session announcer 
			on: aAnnouncement
			send: #announced:
			to: listener
! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 9/23/2012 18:50'!
testThatItCanChangeNick
	translator should receive: #translateChangeNick:; with: 'newnick'.
	session changeNick: 'newnick'.
! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 9/22/2012 23:48'!
testThatItCanJoinToChan
	translator should receive: #translateJoin:; with: '#chan'.
	session joinChan: '#chan'.
! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 9/26/2012 19:30'!
testThatItCanQuit
	translator should receive: #translateQuit.
	session close.
! !

!IrkaSessionTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/28/2012 18:18'!
testThatItForwardsIncomingMessageToChan
	| chan event senderUser |
	chan := self joined: '#chan'.	
	senderUser := IrkaUser parse: 'nick!!ident@host'.
	chan announcer on: IrkaChanMessage send: #msg: to: listener.	
	event := IrkaChanMessage 
					message: 'text'
					on: chan
					fromUser: senderUser.
					
	listener should receive: #msg:; with: event.
	self user: senderUser said: 'text' to: '#chan'.! !

!IrkaSessionTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/28/2012 18:48'!
testThatItForwardsIncomingMessageToMe
	| event senderUser |		
	senderUser := IrkaUser parse: 'nick!!ident@host'.
	self registerNick.	
	self subscribeToSession: IrkaPrivMessage.
	event := IrkaPrivMessage 
					message: 'text'					
					fromUser: senderUser
					session: session.

	listener should receive: #announced:; with: event.	
	self user: senderUser said: 'text' to: me.! !

!IrkaSessionTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/28/2012 18:29'!
testThatItNotifiesWhenIjoinedToChan
	| event |
	self registerNick.
	self subscribeToSession: IrkaSelfjoined.
	event := IrkaSelfjoined 
					user: meUser
					to: (IrkaChannel 
								named: '#chan' 
								translator: translator).
								
	listener should receive: #announced:; with: event.		
	self joined: '#chan'.
! !

!IrkaSessionTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/28/2012 18:48'!
testThatItNotifiesWhenUserJoinedToChan
	| event user |
	user := IrkaUser parse: 'user!!ident@host'.	
	event := IrkaUserJoined
					user: user
					to: (IrkaChannel 
								named: '#chan' 
								translator: translator).
	self subscribeToSession: IrkaUserJoined.		
			
	listener should receive: #announced:; with: event.	
	self user: user joinedTo: '#chan'.
! !

!IrkaSessionTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/28/2012 17:48'!
testThatItRecordsJoinedUsersInChannels
	| chan1 chan2 |			
	chan1 := self joined: '#chan1'.
	chan2 := self joined: '#chan2'.			
	self user: (IrkaUser parse: 'nick!!ident@host') joinedTo: '#chan1'.
	self assert: (self chan: chan1 hasNicks: {me. 'nick'}).
	self assert: (self chan: chan2 hasNicks: {me}).! !

!IrkaSessionTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/28/2012 17:49'!
testThatItRecordsUsersAfterNickListReceived
	| chan |
	chan := self joined: '#chan'.
	session translated: (IrkaTranslatedEvent 
									nickList: #(nick1 nick2) 
									on: '#chan').
	self assert: (self 
						chan: chan 
						hasNicks: {'nick1'. 'nick2'}). ! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 9/26/2012 22:49'!
testThatItRegistersItself
	translator should receive: #translateRegisterUser:; with: me.
	session register: me.
! !

!IrkaSessionTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/28/2012 18:50'!
testThatItRemembersItsNick
	session translated: (IrkaTranslatedEvent 
									user: meUser
									changedNickTo: 'newnick').
	self assert: session nick equals: 'newnick'.
		
	session translated: (IrkaTranslatedEvent 
									user: (IrkaUser parse: 'newnick!!me@host')
									changedNickTo: 'newest').
	self assert: session nick equals: 'newest'.! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 18:16'!
user: anIrkaUser joinedTo: chanName
	session translated: (IrkaTranslatedEvent joined: anIrkaUser to: chanName)! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 18:24'!
user: anIrkaUser said: msg to: chanOrNickString
	session translated: (IrkaTranslatedEvent 
									message: msg 
									from: anIrkaUser 
									to: chanOrNickString).! !

BabyMockTestCase subclass: #IrkaTranslatorTest
	instanceVariableNames: 'translator destination listener'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaTranslatorTest methodsFor: 'running' stamp: 'AttilaMagyar 10/27/2012 22:38'!
setUp
	listener := context mock: 'listener'.
	destination := context mock: 'destination'.
	translator := IrkaIrcTranslator toDestination: destination.
	context visualize: translator.! !

!IrkaTranslatorTest methodsFor: 'private' stamp: 'AttilaMagyar 10/27/2012 22:39'!
subscribeTo: anAnnouncement
	translator announcer on: anAnnouncement send: #announced: to: listener.! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesJoinMessage
	destination should receive: #send:; with: 'JOIN #chan'.
	translator translateJoin: '#chan'.! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesLeave
	destination should receive: #send:; with: 'PART #chan'.
	translator translateLeave: '#chan'.! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 10/27/2012 22:35'!
testThatItTranslatesMessage
	destination should receive: #send:; with: 'PRIVMSG #chan :some text'.
	translator 
		translateMessage: 'some text' 
		to: '#chan'.! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 10/27/2012 22:50'!
testThatItTranslatesNameListCommand
	| event |	
	event := IrkaTranslatedEvent 
					nickList: #(mynick othernick) 
					on: '#chan'.
	self subscribeTo: IrkaTranslatedNameList.	
		
	listener should receive: #announced:; with: event.	
	translator translateRaw: (RawLineReceived parse: ':server 353 mynick = #chan :mynick othernick').! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 10/27/2012 22:53'!
testThatItTranslatesNameListCommandWithAtSeparator
	| event |	
	event := IrkaTranslatedEvent 
					nickList: #('@mynick') 
					on: '#chan'.
	self subscribeTo: IrkaTranslatedNameList.
	
	listener should receive: #announced:; with: event.	
	translator translateRaw: (RawLineReceived parse: ':server 353 mynick @ #chan :@mynick').! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesNickChange
	destination should receive: #send:; with: 'NICK newnick'.
	translator translateChangeNick: 'newnick'.! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesQuit
	destination should receive: #send:; with: 'QUIT'.
	destination should receive: #disconnect.
	translator translateQuit.! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 10/28/2012 18:16'!
testThatItTranslatesRawJoin
	| event |	
	event := IrkaTranslatedEvent 
					joined: (IrkaUser parse: 'nick!!ident@host')
					to: '#chan'.					
	self subscribeTo: IrkaTranslatedJoin.
											
	listener should receive: #announced:; with: event.
	translator translateRaw: (RawLineReceived parse: 'nick!!ident@host JOIN #chan').! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 10/28/2012 18:28'!
testThatItTranslatesRawNickChange
	| event |	
	event := IrkaTranslatedEvent 
					user: (IrkaUser parse: ':nick!!~ident@host.net')
					changedNickTo: 'newnick'.							
	self subscribeTo: IrkaTranslatedNickChange.							
								
	listener should receive: #announced:; with: event.
	translator translateRaw: (RawLineReceived parse: ':nick!!~ident@host.net NICK :newnick').! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 10/28/2012 18:26'!
testThatItTranslatesRawPrivMsg
	| event |	
	event := IrkaTranslatedEvent 
					message: 'msg 1 2'
					from: (IrkaUser parse: 'nick!!ident@host')
					to: '#chan'.						
	self subscribeTo: IrkaTranslatedMessage.
	
	listener should receive: #announced:; with: event.
	translator translateRaw: (RawLineReceived parse: ':nick!!ident@host PRIVMSG #chan :msg 1 2').! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesRegisterMessage
	destination should receive: #send:; with: 'NICK nick'.
	destination should receive: #send:; with: 'USER nick Server 0 :nick'.	
	translator translateRegisterUser: 'nick'.! !

BabyMockTestCase subclass: #IrkaUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaUserTest methodsFor: 'tests' stamp: 'AttilaMagyar 9/25/2012 16:11'!
testThatItCanParseHostAndNick
	| user |
	user := IrkaUser parse: ':nick!!~ident@host.hu'.
	self assert: user nick equals: 'nick'.
	self assert: user ident equals: 'ident'.
	self assert: user host equals: 'host.hu'.! !

!IrkaUserTest methodsFor: 'tests' stamp: 'AttilaMagyar 9/25/2012 16:21'!
testThatItSignalsErrorIfHostIsIncorrect
	self should: [ IrkaUser parse: 'incorrect' ] raise: IrkaError.! !

Morph subclass: #IrkaMessagesMorph
	instanceVariableNames: 'messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaMessagesMorph methodsFor: 'adding' stamp: 'AttilaMagyar 9/24/2012 23:06'!
addMessage: message
	messages add: message! !

!IrkaMessagesMorph methodsFor: 'initialization' stamp: 'AttilaMagyar 9/26/2012 20:48'!
initialize 
	| listBox |
	super initialize.
	self hResizing: #spaceFill; vResizing: #spaceFill; color: Color transparent; layoutPolicy: TableLayout new.
	messages := IrkaListModel new.
	listBox := (PluggableListMorph 
				on: messages list: #list selected: #index changeSelected: #index: menu: #menu) 
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				yourself.
	self addMorph: listBox.! !

Announcement subclass: #IrkaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaAction subclass: #IrkaChanMessage
	instanceVariableNames: 'chan message senderUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaChanMessage class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/27/2012 23:26'!
message: message on: anIrkaChan fromUser: anIrkaUser
	^ self new 
			setMessage: message 
			on: anIrkaChan
			from: anIrkaUser! !

!IrkaChanMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 23:47'!
= anObject
	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ senderUser = anObject user and: [ chan = anObject chan and: [ message = anObject message ] ]! !

!IrkaChanMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 9/22/2012 23:04'!
chan
	^ chan! !

!IrkaChanMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:22'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ senderUser hash bitXor: (chan hash bitXor: message hash)! !

!IrkaChanMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 9/22/2012 23:04'!
message
	^ message! !

!IrkaChanMessage methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 20:58'!
printOn: aStream
	aStream 
		print: senderUser;
		nextPutAll: ' sent message: ';
		print: message;
		nextPutAll: ' to: ';
		print: chan.! !

!IrkaChanMessage methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 23:35'!
setMessage: aMessage on: anIrkaChannel from: anIrkaUser
	message := aMessage.
	chan := anIrkaChannel.
	senderUser := anIrkaUser.! !

!IrkaChanMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:58'!
user
	^ senderUser! !

IrkaAction subclass: #IrkaJoined
	instanceVariableNames: 'chan user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaJoined class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/28/2012 17:51'!
user: anIrkaUser to: anIrkaChan
	^ self new 
			setUser: anIrkaUser 
			chan: anIrkaChan! !

!IrkaJoined methodsFor: 'comparing' stamp: 'AttilaMagyar 10/28/2012 00:31'!
= anObject
	"Answer whether the receiver and anObject represent the same object."
	
	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ chan = anObject chan and: [ user = anObject user ]! !

!IrkaJoined methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 00:16'!
chan
	^ chan! !

!IrkaJoined methodsFor: 'comparing' stamp: 'AttilaMagyar 10/28/2012 00:18'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ chan hash bitXor: user hash! !

!IrkaJoined methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 00:16'!
printOn: aStream
	aStream 
		print: user;
		nextPutAll: ' joined to: ';
		print: chan.! !

!IrkaJoined methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 19:33'!
setUser: anIrkaUser chan: anIrkaChan
	user := anIrkaUser.
	chan := anIrkaChan.! !

!IrkaJoined methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 00:16'!
user
	^ user! !

IrkaJoined subclass: #IrkaSelfjoined
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaJoined subclass: #IrkaUserJoined
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaAction subclass: #IrkaPrivMessage
	instanceVariableNames: 'message senderUser session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaPrivMessage class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/27/2012 23:54'!
message: message fromUser: anIrkaUser session: anIrkaSession
	^ self new 
			setMessage: message 
			senderUser: anIrkaUser
			session: anIrkaSession! !

!IrkaPrivMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/28/2012 00:05'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ senderUser = anObject senderUser and: 
		[ session identityHash = anObject session identityHash and: 
		[ message = anObject message ] ]! !

!IrkaPrivMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 23:54'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ senderUser hash bitXor: (session hash bitXor: message hash)! !

!IrkaPrivMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:53'!
message
	^ message! !

!IrkaPrivMessage methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 20:57'!
printOn: aStream
	aStream 
		print: senderUser;
		nextPutAll: ' sent message: ';
		print: message;
		nextPutAll: ' session: ';
		print: session.! !

!IrkaPrivMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:54'!
senderUser
	^ senderUser! !

!IrkaPrivMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:54'!
session
	^ session! !

!IrkaPrivMessage methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 20:52'!
setMessage: messageString senderUser: anIrkaUser session: anIrkaSession 
	message := messageString.
	senderUser := anIrkaUser.
	session := anIrkaSession.! !

Announcement subclass: #IrkaTranslatedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/28/2012 18:14'!
joined: anIrkaUser to: chanName
	^ IrkaTranslatedJoin new 
			setUser: anIrkaUser
			chanName: chanName! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/28/2012 18:24'!
message: msg from: anIrkaUser to: chanOrNickString
	^ IrkaTranslatedMessage new 
			setSenderUser: anIrkaUser
			recipient: chanOrNickString
			message: msg.! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/27/2012 01:11'!
nickList: anArray on: chanName
	^ IrkaTranslatedNameList new 
					setNicks: anArray 
					chanName: chanName.! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/28/2012 18:27'!
user: anIrkaUser changedNickTo: newNick
	^ IrkaTranslatedNickChange new 
			setUser: anIrkaUser
			newNick: newNick! !

IrkaTranslatedEvent subclass: #IrkaTranslatedJoin
	instanceVariableNames: 'user chanName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedJoin methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:53'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ chanName = anObject chanName ]! !

!IrkaTranslatedJoin methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 01:16'!
chanName 
	^ chanName! !

!IrkaTranslatedJoin methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:53'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: chanName hash! !

!IrkaTranslatedJoin methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 22:55'!
printOn: aStream
	aStream
		nextPutAll: 'User joined: ';
		print: user;
		nextPutAll: 'to ';
		print: chanName! !

!IrkaTranslatedJoin methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 01:10'!
setUser: anIrkaUser chanName: aString
	user := anIrkaUser.
	chanName := aString.! !

!IrkaTranslatedJoin methodsFor: 'accessing' stamp: 'AttilaMagyar 10/26/2012 23:33'!
user
	^ user! !

!IrkaTranslatedJoin methodsFor: 'questions' stamp: 'AttilaMagyar 9/15/2012 23:08'!
whatHappened: questioner
	questioner joined: self! !

IrkaTranslatedEvent subclass: #IrkaTranslatedLeave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaTranslatedEvent subclass: #IrkaTranslatedMessage
	instanceVariableNames: 'message user recipientName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:58'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ message = anObject message and: [ user = anObject senderUser and: [ recipientName = anObject recipientName ] ]! !

!IrkaTranslatedMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:58'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ message hash bitXor: (user hash bitXor: recipientName hash)! !

!IrkaTranslatedMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:08'!
message
	^ message! !

!IrkaTranslatedMessage methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 23:01'!
printOn: aStream
	aStream
		nextPutAll: 'Message: ';
		print: message;
		nextPutAll: ' from: ';
		print: user;
		nextPutAll: ' to: ';
		print: recipientName! !

!IrkaTranslatedMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:26'!
recipientName 
	^ recipientName ! !

!IrkaTranslatedMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:21'!
senderUser
	^ user! !

!IrkaTranslatedMessage methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 20:26'!
setSenderUser: anIrkaUser recipient: chanOrNickString message: messageString
	user := anIrkaUser.
	recipientName := chanOrNickString.
	message := messageString.! !

!IrkaTranslatedMessage methodsFor: 'questions' stamp: 'AttilaMagyar 10/27/2012 20:26'!
whatHappened: questioner
	questioner messageReceived: self.! !

IrkaTranslatedEvent subclass: #IrkaTranslatedNameList
	instanceVariableNames: 'nicks chanName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedNameList methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:47'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ nicks = anObject nicks and: [ chanName = anObject chanName ]! !

!IrkaTranslatedNameList methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 01:19'!
chanName
	^ chanName! !

!IrkaTranslatedNameList methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:47'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ nicks hash bitXor: chanName hash! !

!IrkaTranslatedNameList methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 00:33'!
nicks
	^ nicks! !

!IrkaTranslatedNameList methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 22:52'!
printOn: aStream
	aStream
		nextPutAll: 'Translated namelist: ';
		print: nicks;
		nextPutAll: ' chanName: ';
		print: chanName! !

!IrkaTranslatedNameList methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 01:12'!
setNicks: anArray chanName: aString 
	nicks := anArray.
	chanName := aString.! !

!IrkaTranslatedNameList methodsFor: 'questions' stamp: 'AttilaMagyar 10/27/2012 01:11'!
whatHappened: questioner
	questioner nickListReceived: nicks on: chanName! !

IrkaTranslatedEvent subclass: #IrkaTranslatedNickChange
	instanceVariableNames: 'user nick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedNickChange methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:55'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ nick = anObject nick ]! !

!IrkaTranslatedNickChange methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:55'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: nick hash! !

!IrkaTranslatedNickChange methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 01:16'!
nick
	^ nick! !

!IrkaTranslatedNickChange methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 22:57'!
printOn: aStream
	aStream
		nextPutAll: 'User: ';
		print: user;
		nextPutAll: ' changed nick to: ';
		print: nick! !

!IrkaTranslatedNickChange methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 01:14'!
setUser: anIrkaUser newNick: aString
	user := anIrkaUser.
	nick := aString.! !

!IrkaTranslatedNickChange methodsFor: 'accessing' stamp: 'AttilaMagyar 9/25/2012 14:19'!
user
	^ user! !

!IrkaTranslatedNickChange methodsFor: 'questions' stamp: 'AttilaMagyar 9/26/2012 22:33'!
whatHappened: questioner
	questioner user: user changedNickTo: nick.! !

Announcement subclass: #RawLineReceived
	instanceVariableNames: 'sender command args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!RawLineReceived class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/27/2012 19:41'!
parse: line
	| args command tokens sender |
	args := line findTokens: ' '.
	tokens := args removeFirst: 2.
	sender := tokens at: 1.
	command := tokens at: 2.
	args := ' ' join: args.
	^ self new 
			setSender: sender
			command: command
			args: args! !

!RawLineReceived methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:51'!
args
	^ args! !

!RawLineReceived methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:51'!
command
	^ command! !

!RawLineReceived methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 22:45'!
printOn: aStream
	aStream 
		print: 'command: ';
		print: command;
		print: ' with: ';
		print: args;
		print: ' from: ';
		print: sender.! !

!RawLineReceived methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:51'!
sender
	^ sender! !

!RawLineReceived methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 19:42'!
setSender: senderString command: commandString args: argsString
	sender := senderString.
	command := commandString.
	args := argsString.! !

Object subclass: #Irka
	instanceVariableNames: 'connection translator session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!Irka class methodsFor: 'instance creation' stamp: 'AttilaMagyar 9/22/2012 18:42'!
host: hostName port: portNumber
	| hostIP |
	hostIP := NetNameResolver addressForName: hostName.
	^ self new ip: hostIP port: portNumber.! !

!Irka methodsFor: 'as yet unclassified' stamp: 'AttilaMagyar 10/27/2012 20:04'!
ip: hostIp port: portNumber
	connection := IrkaIrcConnection to: hostIp port: portNumber.
	session := IrkaSession new.
	translator := IrkaIrcTranslator toDestination: connection.
	session translator: translator.	
	connection announcer on: RawLineReceived send: #translateRaw: to: translator.	
	translator announcer on: IrkaTranslatedEvent send: #translated: to: session.		
	[ connection startProcessing ] forkNamed: 'Irka-IRC'.
	^ session.! !

!Irka methodsFor: 'as yet unclassified' stamp: 'AttilaMagyar 9/22/2012 18:40'!
stop
	connection disconnect.! !

Object subclass: #IrkaChannel
	instanceVariableNames: 'chanName announcer translator nicks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaChannel class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/26/2012 22:09'!
named: chanName translator: anIrkaTranslator
	^ self new 
			setChanName: chanName 
			translator: anIrkaTranslator.! !

!IrkaChannel methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:24'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ chanName = anObject chanName! !

!IrkaChannel methodsFor: 'adding' stamp: 'AttilaMagyar 10/26/2012 23:47'!
addNick: aString
	nicks add: aString.! !

!IrkaChannel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/16/2012 12:42'!
announcer 
	^ announcer! !

!IrkaChannel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/15/2012 23:44'!
chanName
	^ chanName! !

!IrkaChannel methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:24'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ chanName hash! !

!IrkaChannel methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/26/2012 23:47'!
initialize 
	super initialize.
	nicks := OrderedCollection new.
	announcer := Announcer new.! !

!IrkaChannel methodsFor: 'commands' stamp: 'AttilaMagyar 9/23/2012 19:22'!
leave
	translator translateLeave: chanName.! !

!IrkaChannel methodsFor: 'commands' stamp: 'AttilaMagyar 10/26/2012 22:07'!
message: message
	translator 
		translateMessage: message 
		to: chanName.! !

!IrkaChannel methodsFor: 'events' stamp: 'AttilaMagyar 10/27/2012 23:34'!
message: msg from: anIrkaUser
	announcer announce: (IrkaChanMessage 
										message: msg 
										on: self 
										fromUser: anIrkaUser).! !

!IrkaChannel methodsFor: 'accessing' stamp: 'AttilaMagyar 10/26/2012 23:48'!
nicks
	^ nicks! !

!IrkaChannel methodsFor: 'adding' stamp: 'AttilaMagyar 10/26/2012 23:47'!
nicks: arrayOfUsers
	nicks removeAll.
	nicks addAll: arrayOfUsers! !

!IrkaChannel methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 00:00'!
printOn: aStream
	chanName printOn: aStream ! !

!IrkaChannel methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/26/2012 22:10'!
setChanName: aString translator: anIrkaTranslator
	chanName := aString.
	translator := anIrkaTranslator.! !

Object subclass: #IrkaIrcConnection
	instanceVariableNames: 'sockStream announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaIrcConnection class methodsFor: 'instance creation' stamp: 'AttilaMagyar 9/22/2012 18:35'!
to: hostIp port: portNumber
	^ self new connectTo: hostIp port: portNumber ! !

!IrkaIrcConnection methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:34'!
announcer
	^ announcer! !

!IrkaIrcConnection methodsFor: 'control' stamp: 'AttilaMagyar 10/26/2012 22:05'!
connectTo: hostIP port: portNumber
	sockStream := SocketStream 
							openConnectionToHost: hostIP 
							port: portNumber.
	sockStream noTimeout.! !

!IrkaIrcConnection methodsFor: 'control' stamp: 'AttilaMagyar 9/17/2012 20:32'!
disconnect
	sockStream close
! !

!IrkaIrcConnection methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/17/2012 20:34'!
initialize 
	super initialize.
	announcer := Announcer new.! !

!IrkaIrcConnection methodsFor: 'private' stamp: 'AttilaMagyar 10/27/2012 19:40'!
parseLine: line
	| tokens |
	line hasIrcPrefix
		ifTrue: 
			[ announcer announce: (RawLineReceived parse: line) ]
		ifFalse: 
			[ (line withoutIrcPrefix beginsWith: 'PING')
				ifTrue: 
					[ self send: (line 
										copyReplaceAll: 'PING' 
										with: 'PONG') ] ]! !

!IrkaIrcConnection methodsFor: 'control' stamp: 'AttilaMagyar 9/17/2012 20:32'!
send: command
	sockStream sendCommand: command! !

!IrkaIrcConnection methodsFor: 'control' stamp: 'AttilaMagyar 10/27/2012 19:39'!
startProcessing
	| line |	
	[ sockStream isConnected ]
		whileTrue:
			[ line := sockStream nextLine.
			self parseLine: line.
			Transcript show: line; cr ]
	! !

Object subclass: #IrkaIrcTranslator
	instanceVariableNames: 'announcer destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaIrcTranslator class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/26/2012 22:00'!
toDestination: destination
	^ self new setDestination: destination.! !

!IrkaIrcTranslator methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 21:08'!
announcer 
	^ announcer ! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 10/27/2012 20:04'!
cmd353: rawLineReceived
	"pharobot4 = #takarodjki :pharobot4 kalohu giszo zeroflag"
	| args chan nicks chanStart chanEnd |
	args := rawLineReceived args.
	chanStart := (self findSeparatorInNickList: args) + 3.
	chanEnd := args findString: ' :' startingAt: chanStart.
	chan := args copyFrom: chanStart to: chanEnd - 1.
	nicks := args copyFrom: chanEnd + 2 to: args size.
	announcer announce: (IrkaTranslatedEvent nickList: (nicks findTokens: ' ') asArray on: chan)! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 10/28/2012 18:15'!
cmdJOIN: rawLineReceived
	| chanName user |
	chanName := rawLineReceived args.
	user := IrkaUser parse: rawLineReceived sender.
	announcer announce: (IrkaTranslatedEvent 
									joined: user
									to: chanName).! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 10/28/2012 18:28'!
cmdNICK: rawLineReceived
	":nick!!~ident@host.net NICK :newnick"
	| newNick user |
	newNick := rawLineReceived args withoutIrcPrefix.
	user := IrkaUser parse: rawLineReceived sender withoutIrcPrefix.
	announcer announce: (IrkaTranslatedEvent 
									user: user 
									changedNickTo: newNick).! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 10/28/2012 18:25'!
cmdPRIVMSG: rawLineReceived
	"command=PRIVMSG args=#funcoder :1 2 3"
	| parts recipient msg senderUser |
	parts := rawLineReceived args findTokens: ' '.
	recipient := parts removeFirst.
	msg := (' ' join: parts) allButFirst: 1.
	senderUser := IrkaUser parse: rawLineReceived sender.
	announcer announce: (IrkaTranslatedEvent 
									message: msg 
									from: senderUser
									to: recipient).! !

!IrkaIrcTranslator methodsFor: 'private' stamp: 'AttilaMagyar 9/26/2012 21:14'!
findSeparatorInNickList: line
	| idx |
	idx := line findString: ' = '.
	idx isZero
		ifTrue: [ idx := line findString: ' @ ' ].
	idx isZero 
		ifTrue: [ IrkaError signal: 'Invalid nicklist format ' , line ].
	^ idx! !

!IrkaIrcTranslator methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/17/2012 21:07'!
initialize 
	super initialize.
	announcer := Announcer new.! !

!IrkaIrcTranslator methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/26/2012 22:00'!
setDestination: dest
	destination := dest! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 9/26/2012 22:26'!
translateChangeNick: newNick 
	destination send: 'NICK ', newNick! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 9/26/2012 22:26'!
translateJoin: chanName
	destination send: 'JOIN ', chanName! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 9/26/2012 22:26'!
translateLeave: chanName 
	destination send: 'PART ', chanName.! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 10/26/2012 22:03'!
translateMessage: message to: target
	destination 
		send: 'PRIVMSG ', target asString, ' :', message asString.! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 10/26/2012 22:03'!
translateQuit
	destination 
		send: 'QUIT'; 
		disconnect.! !

!IrkaIrcTranslator methodsFor: 'translating irc to message' stamp: 'AttilaMagyar 10/26/2012 22:02'!
translateRaw: aRawLineReceived	
	| msg |
	msg := ('cmd', aRawLineReceived command, ':') asSymbol.
	(self respondsTo: msg) ifTrue: 
		[ self perform: msg with: aRawLineReceived ]! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 10/26/2012 22:03'!
translateRegisterUser: aNick
	destination 
		send: 'NICK ', aNick;
		send: 'USER ', aNick, ' Server 0 :', aNick.! !

Object subclass: #IrkaListModel
	instanceVariableNames: 'list index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:55'!
add: element
	list add: element.
	self changed: #list.! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 21:17'!
clean
	list removeAll.
	self changed: #list.! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:30'!
index
	^ index! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:36'!
index: anInteger
	index := anInteger.
	self changed: #index.! !

!IrkaListModel methodsFor: 'initialization' stamp: 'AttilaMagyar 9/23/2012 20:33'!
initialize 
	super initialize.
	index := 0.
	list := OrderedCollection new.! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:30'!
list
	^ list! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:32'!
menu
	^ nil! !

Object subclass: #IrkaSession
	instanceVariableNames: 'translator channels announcer mynick myuser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaSession methodsFor: 'accessing' stamp: 'AttilaMagyar 9/22/2012 19:31'!
announcer 
	^ announcer ! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 9/23/2012 18:50'!
changeNick: newNick 
	translator translateChangeNick: newNick.! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 9/26/2012 19:30'!
close
	translator translateQuit.! !

!IrkaSession methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/26/2012 23:19'!
initialize 
	super initialize.
	channels := Dictionary new.
	announcer := Announcer new.! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 10/27/2012 20:14'!
joinChan: chanName 
	translator translateJoin: chanName asString.! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 10/27/2012 20:24'!
joined: anIrkaTranslatedJoin
	| chan chanName |	
	chanName := anIrkaTranslatedJoin chanName.
	chan := channels 
					at: chanName 
					ifAbsent: [ IrkaChannel named: chanName translator: translator ].
	chan addNick: anIrkaTranslatedJoin user nick.
	channels 
			at: chanName 
			put: chan.
	anIrkaTranslatedJoin user nick = mynick
		ifTrue: 
			[ announcer announce: (IrkaSelfjoined 
												user: anIrkaTranslatedJoin user 
												to: chan) ]
		ifFalse: "TODO forward it to the chan? "
			[ announcer announce: (IrkaUserJoined 
												user: anIrkaTranslatedJoin user 
												to: chan) ]! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 10/27/2012 23:53'!
messageReceived: anIrkaTranslatedChanMsg
	| chan recipient message sender |
	sender := anIrkaTranslatedChanMsg senderUser.
	recipient := anIrkaTranslatedChanMsg recipientName.
	message := anIrkaTranslatedChanMsg message.
	
	recipient = mynick
		ifTrue: 
			[ announcer announce: (IrkaPrivMessage 
												message: message 
												fromUser: sender
												session: self) ]
		ifFalse:
			[ chan := channels 
					at: recipient 
					ifAbsent: [ Error signal: 'Chan not found ', recipient ].
			chan 
				message: message 
				from: sender ]! !

!IrkaSession methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:05'!
nick
	"TODO try to remove me"
	^ mynick! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 10/27/2012 20:11'!
nickListReceived: arrayOfNicks on: chanName
	| chan |
	chan := channels 
				at: chanName 
				ifAbsent: [ Error signal: 'Chan not found ', chanName ].	
	"TODO announce this event"
	chan nicks: arrayOfNicks.! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 10/27/2012 00:05'!
register: aNick
	mynick := aNick.
	translator translateRegisterUser: aNick.! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 10/26/2012 23:05'!
translated: anIrkaTranslated
	anIrkaTranslated whatHappened: self.! !

!IrkaSession methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/15/2012 22:40'!
translator: anIrkaTranslator
	translator := anIrkaTranslator.! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 10/27/2012 20:10'!
user: anIrkaUser changedNickTo: newNick
	(myuser isNil or: [ anIrkaUser nick = mynick ])
		ifTrue:
			[ myuser := anIrkaUser.
			mynick := newNick ]
! !

Object subclass: #IrkaUser
	instanceVariableNames: 'nick host ident'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaUser class methodsFor: 'instance creation' stamp: 'AttilaMagyar 9/25/2012 16:03'!
parse: aString
	^ self new parse: aString ! !

!IrkaUser methodsFor: 'comparing' stamp: 'AttilaMagyar 9/25/2012 17:20'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ nick = anObject nick and: [ host = anObject host and: [ ident = anObject ident ] ]! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 16:52'!
findIdentHostSeparator: hostMask
	| idx |
	idx := hostMask findString: '@' startingAt: (self findNickIdentSeparator: hostMask).
	idx isZero
		ifTrue: [ IrkaError signal: 'Invalid host format ' , hostMask ].
	^ idx	! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 16:46'!
findNickIdentSeparator: hostMask
	| idx |
	idx := hostMask findString: '!!'.
	idx isZero
		ifTrue: [ IrkaError signal: 'Invalid host format ' , hostMask ].
	^ idx! !

!IrkaUser methodsFor: 'comparing' stamp: 'AttilaMagyar 9/25/2012 17:20'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ nick hash bitXor: (host hash bitXor: ident hash)! !

!IrkaUser methodsFor: 'accessing' stamp: 'AttilaMagyar 9/25/2012 16:06'!
host
	^ host! !

!IrkaUser methodsFor: 'accessing' stamp: 'AttilaMagyar 9/25/2012 16:16'!
ident
	^ ident! !

!IrkaUser methodsFor: 'accessing' stamp: 'AttilaMagyar 9/25/2012 16:05'!
nick
	^ nick! !

!IrkaUser methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/25/2012 16:42'!
parse: aString
	"parse hostmasks like :nick!!~ident@host.hu"
	| hostMask |
	hostMask := aString withoutIrcPrefix.
	nick := self parseNick: hostMask.
	ident := self parseIdent: hostMask.
	host := self parseHost: hostMask.! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 17:12'!
parseHost: hostMask
	| hostStart |
	hostStart := (self findIdentHostSeparator: hostMask) +1.
	^ hostMask copyFrom: hostStart to: hostMask size.! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 17:13'!
parseIdent: hostMask
	| identStart identEnd |
	identStart := (self findNickIdentSeparator: hostMask) + 1.
	identEnd := (self findIdentHostSeparator: hostMask) - 1.
	^ self trimTilde: (hostMask copyFrom: identStart to: identEnd)! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 16:48'!
parseNick: hostMask
	^ hostMask copyFrom: 1 to: (self findNickIdentSeparator: hostMask) - 1! !

!IrkaUser methodsFor: 'printing' stamp: 'AttilaMagyar 9/26/2012 23:07'!
printOn: aStream
	^ aStream nextPutAll: nick, '!!', ident, '@', host.! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 17:13'!
trimTilde: fullIdent
	^ (fullIdent beginsWith: '~')
		ifTrue: [ fullIdent allButFirst: 1 ]
		ifFalse: [ fullIdent ]! !

Error subclass: #IrkaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!String methodsFor: '*irka' stamp: 'AttilaMagyar 9/25/2012 14:36'!
hasIrcPrefix
	^ self beginsWith: ':'! !

!String methodsFor: '*irka' stamp: 'AttilaMagyar 9/25/2012 14:37'!
withoutIrcPrefix
	^ (self beginsWith: ':') ifTrue: [ self allButFirst: 1 ] ifFalse: [ self ]! !
